/**
This file was auto-generated by mupdfwrap.py.
*/


#include "mupdf/extra.h"


FZ_FUNCTION std::string fz_lookup_metadata2( fz_context* ctx, fz_document* doc, const char* key)
{
	/* Find length first. */
	int e = fz_lookup_metadata(ctx, doc, key, NULL /*buf*/, 0 /*size*/);
	if (e < 0)
	{
		fz_throw(ctx, FZ_ERROR_GENERIC, "key not found: %s", key);
	}
	assert(e != 0);
	char* buf = (char*) fz_malloc(ctx, e);
	int e2 = fz_lookup_metadata(ctx, doc, key, buf, e);
	assert(e2 = e);
	std::string ret = buf;
	free(buf);
	return ret;
}

FZ_FUNCTION std::string pdf_lookup_metadata2( fz_context* ctx, pdf_document* doc, const char* key)
{
	/* Find length first. */
	int e = pdf_lookup_metadata(ctx, doc, key, NULL /*buf*/, 0 /*size*/);
	if (e < 0)
	{
		fz_throw(ctx, FZ_ERROR_GENERIC, "key not found: %s", key);
	}
	assert(e != 0);
	char* buf = (char*) fz_malloc(ctx, e);
	int e2 = pdf_lookup_metadata(ctx, doc, key, buf, e);
	assert(e2 = e);
	std::string ret = buf;
	free(buf);
	return ret;
}

FZ_FUNCTION std::vector<unsigned char> fz_md5_pixmap2(fz_context *ctx, fz_pixmap *pixmap)
{
	std::vector<unsigned char>  ret(16);
	fz_md5_pixmap( ctx, pixmap, &ret[0]);
	return ret;
}

FZ_FUNCTION long long fz_pixmap_samples_int(fz_context *ctx, fz_pixmap *pixmap)
{
	long long ret = (intptr_t) pixmap->samples;
	return ret;
}

FZ_FUNCTION int fz_samples_get(fz_pixmap *pixmap, int offset)
{
	return pixmap->samples[offset];
}

FZ_FUNCTION void fz_samples_set(fz_pixmap *pixmap, int offset, int value)
{
	pixmap->samples[offset] = value;
}

FZ_FUNCTION std::vector<unsigned char> fz_md5_final2(fz_md5* md5)
{
	std::vector<unsigned char>  ret(16);
	fz_md5_final( md5, &ret[0]);
	return ret;
}

FZ_FUNCTION std::vector<fz_quad> fz_highlight_selection2(fz_context *ctx, fz_stext_page *page, fz_point a, fz_point b, int max_quads)
{
	{
		std::vector<fz_quad>    ret(max_quads);
		int n;
		fz_try(ctx)
		{
			n = fz_highlight_selection(ctx, page, a, b, &ret[0], max_quads);
		}
		fz_catch(ctx)
		{
			n = -1;
		}
		if (n >= 0)
		{
			ret.resize(n);
			return ret;
		}
	}
	/* We are careful to only call `fz_throw()` after `ret`'s
	destructor has been called. */
	fz_throw(ctx, FZ_ERROR_GENERIC, "fz_highlight_selection() failed");
}

FZ_FUNCTION std::vector<fz_search_page2_hit> fz_search_page2(fz_context *ctx, fz_document *doc, int number, const char *needle, int hit_max)
{
	std::vector<fz_quad>    quads(hit_max);
	std::vector<int>        marks(hit_max);
	int n = fz_search_page_number(ctx, doc, number, needle, &marks[0], &quads[0], hit_max);
	std::vector<fz_search_page2_hit>    ret(n);
	for (int i=0; i<n; ++i)
	{
		ret[i].quad = quads[i];
		ret[i].mark = marks[i];
	}
	return ret;
}

FZ_FUNCTION std::string fz_string_from_text_language2(fz_text_language lang)
{
	char    str[8];
	fz_string_from_text_language(str, lang);
	return std::string(str);
}
